<template>
  <section waiting>
    <span loader></span>
    <span message>loading...</span>
  </section>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";

@Component
export default class extends Vue {}
</script>

<style scoped lang="scss">
$size: 30px;
$color-circle-outer: #0033a0;
$color-circle-middle: lighten($color-circle-outer, 15);
$color-circle-inner: lighten($color-circle-outer, 30);

@mixin absPosition($top: auto, $right: $top, $bottom: $top, $left: $top) {
  position: absolute;
  top: $top;
  right: $right;
  bottom: $bottom;
  left: $left;
}

@mixin animation($animation...) {
  -webkit-animation: $animation;
  animation: $animation;
}

section[waiting] {
  @include absPosition(0);
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
}

[message] {
  font-size: 0.6em;
  margin-top: 10px;
  opacity: 0.6;
}

[loader] {
  // display: inline-block;
  position: relative;
  width: $size;
  height: $size;
  border-radius: $size;
  border: 1px solid transparent;
  border-top-color: $color-circle-outer;
  @include animation(spin 1s linear infinite);
  &:before,
  &:after {
    content: "";
    border-radius: $size;
    border: 1px solid transparent;
  }
  &:after {
    @include absPosition(3px);
    border-top-color: $color-circle-middle;
    @include animation(spinreverse 5s linear infinite);
  }
  &:before {
    @include absPosition(7px);
    border-top-color: $color-circle-inner;
    @include animation(spinreverse 10s linear infinite);
  }
}

@keyframes spin {
  0% {
    -webkit-transform: rotate(0deg);
    tranform: rotate(0deg);
  }
  100% {
    -webkit-transform: rotate(360deg);
    tranform: rotate(360deg);
  }
}

@keyframes spinreverse {
  0% {
    -webkit-transform: rotate(0deg);
    tranform: rotate(0deg);
  }
  100% {
    -webkit-transform: rotate(-360deg);
    tranform: rotate(-360deg);
  }
}
</style>
